# CMake BALL package configuration file for upstream projects
# Automatically configured by the BALL build system from
# <BALL-Dir>/cmake/BALLConfig.cmake.in

INCLUDE(CMakeFindDependencyMacro)

# Set BALL include directories
SET(BALL_INCLUDE_DIRS "/usr/include/;/usr/include;/usr/include/eigen3;/usr/include")

# Set important CXX compile flags and definitions used for BALL
SET(BALL_CXX_FLAGS " -std=c++0x -pedantic")
SET(BALL_COMPILE_DEFINITIONS "-DQT_NO_KEYWORDS")

# Search required Qt5 dependencies
SET(QT5_IMPORTED_TARGETS Qt5Core;Qt5Network;Qt5Xml;Qt5OpenGL;Qt5PrintSupport;Qt5Test;Qt5Widgets)
FOREACH(QT5_IMPORTED_TARGET ${QT5_IMPORTED_TARGETS})
	 find_dependency(${QT5_IMPORTED_TARGET} 5.5)
ENDFOREACH()


# Create IMPORTED targets for BALL and VIEW
INCLUDE("${CMAKE_CURRENT_LIST_DIR}/BALLExport.cmake")
